using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MissionPlanner.Utilities;
using MissionPlanner.Controls;
using System.IO;
using System.Windows.Forms;
using System.Diagnostics;
using MissionPlanner;
using System.Drawing;
using GMap.NET.WindowsForms;
using MissionPlanner.GCSViews;
using MissionPlanner.Maps;
using MissionPlanner.Comms;
using System.Net.Sockets;
using System.Net;
using System.Threading.Tasks;

namespace mass
{
    public class Pluginmass : MissionPlanner.Plugin.Plugin
    {
        public override string Name
        {
            get { return "GoPro Control"; }
        }

        public override string Version
        {
            get { return "1.0"; }
        }

        public override string Author
        {
            get { return "Tom Brereton"; }
        }

        public override bool Init()
        {
            return true;
        }

        public override bool Loaded()
        {
            var rootbut = new ToolStripMenuItem("MavGoPro RC Control");
            ToolStripItemCollection col = Host.FDMenuMap.Items;
            col.Add(rootbut);

            var but = new ToolStripMenuItem("Capture");
            but.Click += (s, e) => {
                Parallel.ForEach(MainV2.Comports, mav => {
                    try
                    {
                        mav.doCommand(1, (byte)MAVLink.MAV_COMPONENT.MAV_COMP_ID_CAMERA, MAVLink.MAV_CMD.DO_DIGICAM_CONTROL, 0, 0, 0, 0, 0, 0, 0);
                    }
                    catch { }
                });
            };
            rootbut.DropDownItems.Add(but);

            but = new ToolStripMenuItem("Set Mode: Photo");
            but.Click += (s, e) => {
                Parallel.ForEach(MainV2.Comports, mav =>
                {
                    try
                    {
                        mav.doCommand(1, (byte)MAVLink.MAV_COMPONENT.MAV_COMP_ID_CAMERA, MAVLink.MAV_CMD.DO_DIGICAM_CONFIGURE, 0, 0, 0, 0, 0, 0, 0);
                    }
                    catch { }
                });
            };
            rootbut.DropDownItems.Add(but);

            but = new ToolStripMenuItem("Set Mode: Video");
            but.Click += (s, e) => {
                Parallel.ForEach(MainV2.Comports, mav => {
                    try
                    {
                        mav.doCommand(1, (byte)MAVLink.MAV_COMPONENT.MAV_COMP_ID_CAMERA, MAVLink.MAV_CMD.DO_DIGICAM_CONFIGURE, 1, 0, 0, 0, 0, 0, 0);
                    } catch { }
                });
            };
            rootbut.DropDownItems.Add(but);

            but = new ToolStripMenuItem("Set Mode: Timelapse");
            but.Click += (s, e) => {
                Parallel.ForEach(MainV2.Comports, mav => {
                    try
                    {
                        mav.doCommand(1, (byte)MAVLink.MAV_COMPONENT.MAV_COMP_ID_CAMERA, MAVLink.MAV_CMD.DO_DIGICAM_CONFIGURE, 2, 0, 0, 0, 0, 0, 0);
                    }
                    catch { }
                });
            };
            rootbut.DropDownItems.Add(but);

            return true;
        }

        public override bool Loop()
        {
            return true;
        }

        public override bool Exit()
        {
            return true;
        }
    }
}